import 'dart:collection';

import 'package:_private_core/_private_core.dart';
import 'package:_private_core_network/network_resources/resources.dart';
import 'app_api.dart'; 

class LegalRepo {
  LegalRepo._();

  static LegalRepo? _instance;

  factory LegalRepo([MyAppApi? api]) {
    _instance ??= LegalRepo._();
    _instance!._api = api ?? MyAppApiImp();
    return _instance!;
  }

  late MyAppApi _api;

  Map<String, dynamic> _mapParms([Map? value]) {
    Map<String, dynamic> params = {};
    if (value != null && value.isNotEmpty) params.addAll(HashMap.from(value));
    params
      ..removeWhere((key, value) => value == null)
      ..addAll({
        'platformId': valuePlatformByConfig(),
        'languageCode': appPrefs.languageCode,
      });
    return params;
  }

  Future<bool> acceptTerms(params) async {
    NetworkResponse response = await _api.acceptTerms(_mapParms(params));
    return response.data ?? false;
  }

  Future<LegalInfo?> getLegalContent(params) async {
    NetworkResponse response = await _api.getLegalContent(_mapParms(params));
    return response.data;
  }
}
