import 'br_place_filter.dart';

class BrPlaceModel {
  String? id;
  String? name;
  String? description;
  String? subtitle;
  String? pictureUrl;
  int? globalNote;
  double? lat;
  double? lng;
  String? street1;
  String? street2;
  String? zip;
  String? city;
  String? state;
  String? country;
  String? catName;
  String? colorCode;
  String? colorCode2;
  String? catThumbnail;
  List<BrPlaceFilterModel>? filters;

  BrPlaceModel(
      {this.id,
      this.name,
      this.description,
      this.subtitle,
      this.pictureUrl,
      this.globalNote,
      this.lat,
      this.lng,
      this.street1,
      this.street2,
      this.zip,
      this.city,
      this.state,
      this.country,
      this.catName,
      this.colorCode,
      this.colorCode2,
      this.catThumbnail,
      this.filters});

  bool favorite = false;

  BrPlaceModel.fromJson(Map<String, dynamic> json) {
    this.favorite = json["favorite"] == 1;
    if (json["id"] is String) this.id = json["id"];
    if (json["name"] is String) this.name = json["name"];
    if (json["description"] is String) this.description = json["description"];
    if (json["subtitle"] is String) this.subtitle = json["subtitle"];
    if (json["pictureUrl"] is String) this.pictureUrl = json["pictureUrl"];
    if (json["globalNote"] is int) this.globalNote = json["globalNote"];
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
    if (json["street1"] is String) this.street1 = json["street1"];
    if (json["street2"] is String) this.street2 = json["street2"];
    if (json["zip"] is String) this.zip = json["zip"];
    if (json["city"] is String) this.city = json["city"];
    if (json["state"] is String) this.state = json["state"];
    if (json["country"] is String) this.country = json["country"];
    if (json["catName"] is String) this.catName = json["catName"];
    if (json["colorCode"] is String) this.colorCode = json["colorCode"];
    if (json["colorCode2"] is String) this.colorCode2 = json["colorCode2"];
    if (json["catThumbnail"] is String) this.catThumbnail = json["catThumbnail"];
    if (json["filters"] is List)
      this.filters = json["filters"] == null
          ? []
          : (json["filters"] as List).map((e) => BrPlaceFilterModel.fromJson(e)).toList();
    else
      filters = [];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["name"] = this.name;
    data["description"] = this.description;
    data["subtitle"] = this.subtitle;
    data["pictureUrl"] = this.pictureUrl;
    data["globalNote"] = this.globalNote;
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    data["street1"] = this.street1;
    data["street2"] = this.street2;
    data["zip"] = this.zip;
    data["city"] = this.city;
    data["state"] = this.state;
    data["country"] = this.country;
    data["catName"] = this.catName;
    data["colorCode"] = this.colorCode;
    data["colorCode2"] = this.colorCode2;
    data["catThumbnail"] = this.catThumbnail;
    if (this.filters != null) data["filters"] = this.filters?.map((e) => e.toJson()).toList();
    return data;
  }
}
