class TrackingInfoModel {
  int? id;
  int? allowedTimeBeforeTrack;
  double? allowedDistanceBeforeTrack;
  int? manualStatus;
  _UserInfo? userInfo;
  _ProInfo? proInfo;

  TrackingInfoModel(
      {this.id,
      this.allowedTimeBeforeTrack,
      this.allowedDistanceBeforeTrack,
      this.manualStatus,
      this.userInfo,
      this.proInfo});

  TrackingInfoModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["allowedTimeBeforeTrack"] is int)
      this.allowedTimeBeforeTrack = json["allowedTimeBeforeTrack"];
    if (json["allowedDistanceBeforeTrack"] is double)
      this.allowedDistanceBeforeTrack = json["allowedDistanceBeforeTrack"];
    if (json["manualStatus"] is int) this.manualStatus = json["manualStatus"];
    if (json["userInfo"] is Map)
      this.userInfo =
          json["userInfo"] == null ? null : _UserInfo.fromJson(json["userInfo"]);
    if (json["proInfo"] is Map)
      this.proInfo =
          json["proInfo"] == null ? null : _ProInfo.fromJson(json["proInfo"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["allowedTimeBeforeTrack"] = this.allowedTimeBeforeTrack;
    data["allowedDistanceBeforeTrack"] = this.allowedDistanceBeforeTrack;
    data["manualStatus"] = this.manualStatus;
    if (this.userInfo != null) data["userInfo"] = this.userInfo?.toJson();
    if (this.proInfo != null) data["proInfo"] = this.proInfo?.toJson();
    return data;
  }
}

class _ProInfo {
  int? id;
  String? firebaseId;

  _ProInfo({this.id, this.firebaseId});

  _ProInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["firebaseId"] is String) this.firebaseId = json["firebaseId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["firebaseId"] = this.firebaseId;
    return data;
  }
}

class _UserInfo {
  int? id;
  String? firebaseId;

  _UserInfo({this.id, this.firebaseId});

  _UserInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["firebaseId"] is String) this.firebaseId = json["firebaseId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["firebaseId"] = this.firebaseId;
    return data;
  }
}
