import '../resources.dart';

class CrmRepo {
  CrmRepo._();

  static CrmRepo? _instance;

  factory CrmRepo([AppApi? api]) {
    _instance ??= CrmRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<CrmStatus>> getCrmStatusList(params) async {
    NetworkResponse response = await _api.getCrmStatusList(params);
    return response.data ?? [];
  }

  Future<List<CrmLead>> getListOfLeadsFromPro(params) async {
    NetworkResponse response = await _api.getListOfLeadsFromPro(params);
    return response.data ?? [];
  }

  Future<List<CrmIntouch>> getCrmIntouchList(params) async {
    NetworkResponse response = await _api.getCrmIntouchList(params);
    return response.data ?? [];
  }

  Future<bool> createCrmProjectFromPro(params) async {
    NetworkResponse response = await _api.createCrmProjectFromPro(params);
    return response.data ?? false;
  }

  Future<List<CrmProject>> getListCrmProjectsFromPro(params) async {
    NetworkResponse response = await _api.getListCrmProjectsFromPro(params);
    return response.data ?? [];
  }

  Future<List<CrmIntouchHistory>> getCrmLeadHistory(params) async {
    NetworkResponse response = await _api.getCrmLeadHistory(params);
    return response.data ?? [];
  }

  Future<bool> createCrmLead(params) async {
    NetworkResponse response = await _api.createCrmLead(params);
    return response.data ?? false;
  }

  Future<bool> createInTouchHistory(params) async {
    NetworkResponse response = await _api.createInTouchHistory(params);
    return response.data ?? false;
  }

  Future<bool> updateCrmLead(params) async {
    NetworkResponse response = await _api.updateCrmLead(params);
    return response.data ?? false;
  }

  Future<String?> setThumbnailForCrmLead(bytes, path, uuid) async {
    NetworkResponse response =
        await _api.setThumbnailForCrmLead(bytes, path, uuid);
    return response.data;
  }

  Future<bool> deleteCrmLead(params) async {
    NetworkResponse response = await _api.deleteCrmLead(params);
    return response.data ?? false;
  }

  Future<bool> addCrmLeadsToProject(params) async {
    NetworkResponse response = await _api.addCrmLeadsToProject(params);
    return response.data ?? false;
  }

  Future<bool> removeCrmLeadsToProject(params) async {
    NetworkResponse response = await _api.removeCrmLeadsToProject(params);
    return response.data ?? false;
  }

  Future<CrmLead?> getCrmLeadDetails(params) async {
    NetworkResponse response = await _api.getCrmLeadDetails(params);
    return response.data;
  }

  Future<List<ProInfo>> getCrmProjectMemberList(params) async {
    NetworkResponse response = await _api.getCrmProjectMemberList(params);
    return response.data ?? [];
  }

  Future<bool> addCrmProjectMember(params) async {
    NetworkResponse response = await _api.addCrmProjectMember(params);
    return response.data ?? false;
  }

  Future<bool> removeCrmProjectMember(params) async {
    NetworkResponse response = await _api.removeCrmProjectMember(params);
    return response.data ?? false;
  }
}
