import '../resources.dart';

class TerminalRepo {
  TerminalRepo._();

  static TerminalRepo? _instance;

  factory TerminalRepo() {
    _instance ??= TerminalRepo._();
    return _instance!;
  }

  final AppApiImp _api = AppApiImp();

  Future<List<Terminal>> getTerminalsFromPro(terminalType) async {
    NetworkResponse response = await _api.getTerminalsFromPro(terminalType);
    return response.data ?? [];
  }

  Future<List<Terminal>> getAllTerminalFromAdmin(params) async {
    NetworkResponse response = await _api.getAllTerminalFromAdmin(params);
    return response.data ?? [];
  }

  Future<bool> updateTerminalFromPro(params) async {
    NetworkResponse response = await _api.updateTerminalFromPro(params);
    return response.data ?? false;
  }

  Future<bool> sendHomeToTerminal(params) async {
    NetworkResponse response = await _api.sendHomeToTerminal(params);
    return response.data ?? false;
  }

  Future<bool> removeHomeFromTerminal(params) async {
    NetworkResponse response = await _api.removeHomeFromTerminal(params);
    return response.data ?? false;
  }

  Future<bool> linkTerminalToProV2(params) async {
    NetworkResponse response = await _api.linkTerminalToProV2(params);
    return response.data ?? false;
  }

  Future<List<Terminal>> v2_getCurrentTerminalsOfPlaylistFromPro(params) async {
    NetworkResponse response =
        await _api.v2_getCurrentTerminalsOfPlaylistFromPro(params);
    return response.data ?? [];
  }
}
